function d = distance( v1, v2, varargin)
% computes distance for every vector V1, V2 column
% if V1 is a column vector distance is computed with V1 being the reference
% vector and V2 can be of any number of columns

	d = [];
	r1 = size(v1,1); r2 = size(v2,1);
	c1 = size(v1,2); c2 = size(v2,2);
	
	if r1~=r2
		error('Wrong parameter! The input vectors should have the same number of rows!');
	end;
	
	if c1>c2
		error('Wrong parameters! Size of V2 must be at lest equal to the size of V1.');
	elseif c1==c2
		l = c1;
		m = 0;
	elseif c1<c2 && c1>1
		error('Wrong parameters! If size of V2 is greater than the size of V1 then V1 should be of size (N X 1).');
	else
		l = c2;
		m = 1;
	end
	
	switch nargin
		case 2					% Euclidean distance
			if ~m,
				for i=1:l,
					d(end+1) = sqrt((v1(:,i)-v2(:,i))'*(v1(:,i)-v2(:,i)));
				end
			else
				for i=1:l,
					d(end+1) = sqrt((v1-v2(:,i))'*(v1-v2(:,i)));
				end
			end;
		otherwise
			error( 'Wrong parameters!');
	end
	
	