%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% function a = init_triangles( is_random, num_triangles)
%
%          function that produces triangles with random sides' length
%          if IS_RANDOM is false, the function
%          produces NUM_TRIANGLES number of triangles
%          else provides 2 special cases for 4 and 7 triangles
%

%
% Copyright  11-Mar-2012 George P. Pavlidis (sepdek@sepdek.net)
%
function a = init_triangles( is_random, triangles)

if is_random
	scalinglimits=[1 8];
	randomlimits=[0 1];
	a = zeros( triangles, 3);

	% produce random triangles
	i = 1;
	while i <= triangles,
		for j = 1: 3,
			a(i, j) = round( scale( rand, randomlimits, scalinglimits) * 10) / 10;
		end
		% do a simple check: if a side is greater than half the perimeter then
		% this is probably not a triangle
		if  (a(i, 1) > triangle_perimeter( a(i,:)) / 2) || ...
				(a(i, 2) > triangle_perimeter( a(i,:)) / 2) || ...
				(a(i, 3) > triangle_perimeter( a(i,:)) / 2)
			% do nothing just loop again to get new values
		else
			% OK this is probably a triangle...go ahead with the next one
			i = i + 1;
		end;
	end;
else
	if triangles == 4,
		% initialize 4 triangles with 3 features being the sides' lengths
		a = [2 2.5 1.5; 1.5 1.8 1.5; 1 1.25 0.75; 2 2.5 1.5];
	else
		% initialize 7 triangles with 3 features being the sides' lengths
		a = [2 2.5 1.5; 1.5 1.8 1.5; 1 1.25 0.75; 2 2.5 3.5; 2 2.5 1.5; 3 4 6; 2.5 1.5 3];
	end;
end;
