%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%     function ang = triangle_angles( sides)
%
%             compute the angles of a triangle given the sides' lengths
%             using trigonometry and the law of sines
%             angles are returned in DEGREES
%

%
% Copyright  11-Mar-2012 George P. Pavlidis (sepdek@sepdek.net)
%
function ang = triangle_angles( sides)

	ang(:,1) = acos( (sides(:,2).^2+sides(:,3).^2-sides(:,1).^2) ./ (2*sides(:,2).*sides(:,3)) );
	ang(:,2) = acos( (sides(:,1).^2+sides(:,3).^2-sides(:,2).^2) ./ (2*sides(:,1).*sides(:,3)) );
	ang(:,3) = acos( (sides(:,1).^2+sides(:,2).^2-sides(:,3).^2) ./ (2*sides(:,1).*sides(:,2)) );
	
	ang = rad2deg( ang);